"use strict";
Object.defineProperty(exports, "createReducer", {
    enumerable: true,
    get: ()=>createReducer
});
const _extends = require("@swc/helpers/lib/_extends.js").default;
const _lodash = require("lodash");
const _uuid = require("uuid");
const createReducer = ()=>{
    return function reducer(state, action) {
        switch(action.type){
            case 'insert':
                {
                    const id = (0, _uuid.v4)();
                    const data = _extends({}, state.data, {
                        [id]: {
                            id,
                            children: [],
                            parentId: action.parentId,
                            data: _extends({}, action.item, {
                                id
                            })
                        }
                    });
                    if (action.parentId) {
                        var _data_action_parentId;
                        data[action.parentId] = _extends({}, data[action.parentId], {
                            children: [
                                ...((_data_action_parentId = data[action.parentId]) == null ? void 0 : _data_action_parentId.children) || [],
                                id
                            ]
                        });
                    }
                    return _extends({}, state, {
                        root: (0, _lodash.values)(data).filter((i)=>i && !i.parentId).map((i)=>i.id),
                        data
                    });
                }
            case 'push':
                {
                    const currentPath = state.path;
                    if (action.section !== undefined && currentPath[action.section]) {
                        currentPath.splice(action.section, 1, action.item);
                        currentPath.splice(action.section + 1, currentPath.length - action.section);
                    } else {
                        currentPath.push(action.item);
                    }
                    return _extends({}, state, {
                        path: [
                            ...currentPath
                        ]
                    });
                }
            case 'select':
                {
                    const newPath = [
                        action.item.id
                    ];
                    if (action.item.parentId) {
                        let parentId = action.item.parentId;
                        while(parentId !== ''){
                            const node = state.data[parentId];
                            newPath.push(node.id);
                            parentId = node.parentId || '';
                        }
                    }
                    console.log({
                        newPath
                    });
                    return _extends({}, state, {
                        path: newPath.reverse()
                    });
                }
            case 'pop':
                state.path.pop();
                return _extends({}, state, {
                    path: [
                        ...state.path
                    ]
                });
            default:
                return state;
        }
    };
};

//# sourceMappingURL=index.js.map